local IQT_VERSION = "1.3"
local AIRCRAFT = "F-16C Viper"

local start_flag = 1000
local stop_flag = 1001
local timer_running = false
local start_time = 0

local function start_timer()

    if timer_running == true then
        return
    end

    if trigger.misc.getUserFlag(start_flag) == 1 then
        start_time = timer.getTime()
        timer_running = true
    end

    if trigger.misc.getUserFlag(start_flag) == 0 then
        timer.scheduleFunction(start_timer, nil, timer.getTime() + 1)
    end
end

local function get_iqt_flags()
  local flags = {}
  for i = 1, 9 do
    flags[i] = 0
  end
  for i = 10, 20 do
    flag = trigger.misc.getUserFlag(i)

    if flag == 1 then
      flags[i] = "Passed"
    elseif flag == 2 then
        flags[i] = "Not Evaluated"
    else
        flags[i] = "N/A"
    end
  end
  return flags
end

local function print_report()
    local flags = get_iqt_flags()
    local elapsed_time = timer.getTime() - start_time

    -- convert to minutes and seconds
    local minutes = math.floor(elapsed_time / 60)
    local seconds = elapsed_time - (minutes * 60)
    local time_string = string.format("%d:%02d", minutes, seconds)

    local display = {}
    display[#display + 1] = "Check Ride Report \n"
    display[#display+1] = "Version: " .. AIRCRAFT .. " " .. IQT_VERSION .. "\n\n\n"
    display[#display + 1] = "HARM RUK: " .. flags[10] .. "\n"
    display[#display + 1] = "MK82SE: " .. flags[11] .. "\n"
    display[#display + 1] = "HARM HTS: " .. flags[12] .. "\n"
    display[#display + 1] = "CBU87: " .. flags[13] .. "\n"
    display[#display + 1] = "A2A: " .. flags[14] .. "\n"
    display[#display + 1] = "TACAN Intercept: " .. flags[15] .. "\n"
    display[#display + 1] = "Landing 1: " .. flags[16] .. "\n"
    display[#display + 1] = "GBU-12: " .. flags[17] .. "\n"
    display[#display + 1] = "GBU-38: " .. flags[18] .. "\n"
    display[#display + 1] = "AGM-65: " .. flags[19] .. "\n"
    display[#display + 1] = "Landing 2: " .. flags[20] .. "\n\n"
    display[#display + 1] = "Elapsed time: " .. time_string .. "\n\n\n"
    display[#display + 1] = "Please post this report to the Training and Checkrides post in #93rd-tfs, and with an accompanying Tacview if you took this checkride without a proctor"

    if trigger.misc.getUserFlag(start_flag) == 0 then
        display[#display + 1] = "\n\n\n Check ride not started yet. Elapsed time will reset to zero at check ride start. \n\n\n"
    end

    trigger.action.outText(table.concat(display), 60)
end

local function stop_timer()
    if trigger.misc.getUserFlag(stop_flag) == 1 then
        timer_running = false

        -- print report
        print_report()
    end

    if trigger.misc.getUserFlag(stop_flag) == 0 then
        timer.scheduleFunction(stop_timer, nil, timer.getTime() + 1)
    end
end

timer.scheduleFunction(start_timer, nil, timer.getTime() + 1)
timer.scheduleFunction(stop_timer, nil, timer.getTime() + 1)

missionCommands.addCommand("Print Report", nil, print_report)